searchNodes=[{"ref":"ExHttpMicroservice.html","title":"ExHttpMicroservice","type":"module","doc":"Client library to wrap HTTP connection with common microservice implementation. Use ExHttpMicroservice.Client to define your own service client. Examples defmodule ShopClient do use ExHttpMicroservice.Client # If no override functions are present, the client falls back to the default values # defaults to false def secure?(), do: false # defaults to localhost def host(), do: &quot;shop-microservice&quot; # defaults to 8080 def port(), do: 4000 def list_vegetables() do case get(&quot;/vegetables&quot;) do {:ok, %HTTPoison.Response{ body: %{&quot;data&quot; =&gt; vegetables}, status_code: 200 }} -&gt; {:ok, vegetables} error -&gt; error end end def create_vegetable(vegetable) do case post(&quot;/vegetables&quot;, %{&quot;vegetable&quot; =&gt; vegetable}) do {:ok, %HTTPoison.Response{ body: %{&quot;data&quot; =&gt; created_vegetable}, status_code: 201 }} -&gt; {:ok, created_vegetable} error -&gt; error end end end"},{"ref":"ExHttpMicroservice.Client.html","title":"ExHttpMicroservice.Client","type":"module","doc":"Use this module to declare an interface to an external service. Specify the connection options by overriding functions. Examples defmodule MyUserApiClient do use ExHttpMicroservice.Client # Determines whether requests are made over HTTP or HTTPS. @spec secure?() :: boolean() def secure?(), do: false # The host of the service to fire requests at. @spec host() :: String.t() def host(), do: &quot;localhost&quot; # The port of the service to fire requests at. @spec port() :: pos_integer() def port(), do: 8080 end"},{"ref":"ExampleClient.html","title":"ExampleClient","type":"module","doc":""},{"ref":"ExampleClient.html#create_vegetable/1","title":"ExampleClient.create_vegetable/1","type":"function","doc":""},{"ref":"ExampleClient.html#delete/3","title":"ExampleClient.delete/3","type":"function","doc":"Issues a DELETE request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"ExampleClient.html#delete!/3","title":"ExampleClient.delete!/3","type":"function","doc":"Issues a DELETE request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"ExampleClient.html#get/3","title":"ExampleClient.get/3","type":"function","doc":"Issues a GET request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"ExampleClient.html#get!/3","title":"ExampleClient.get!/3","type":"function","doc":"Issues a GET request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"ExampleClient.html#head/3","title":"ExampleClient.head/3","type":"function","doc":"Issues a HEAD request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"ExampleClient.html#head!/3","title":"ExampleClient.head!/3","type":"function","doc":"Issues a HEAD request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"ExampleClient.html#host/0","title":"ExampleClient.host/0","type":"function","doc":"The host of the service to fire requests at."},{"ref":"ExampleClient.html#list_vegetables/0","title":"ExampleClient.list_vegetables/0","type":"function","doc":""},{"ref":"ExampleClient.html#options/3","title":"ExampleClient.options/3","type":"function","doc":"Issues an OPTIONS request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"ExampleClient.html#options!/3","title":"ExampleClient.options!/3","type":"function","doc":"Issues a OPTIONS request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"ExampleClient.html#patch/4","title":"ExampleClient.patch/4","type":"function","doc":"Issues a PATCH request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"ExampleClient.html#patch!/4","title":"ExampleClient.patch!/4","type":"function","doc":"Issues a PATCH request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"ExampleClient.html#port/0","title":"ExampleClient.port/0","type":"function","doc":"The port of the service to fire requests at."},{"ref":"ExampleClient.html#post/4","title":"ExampleClient.post/4","type":"function","doc":"Issues a POST request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"ExampleClient.html#post!/4","title":"ExampleClient.post!/4","type":"function","doc":"Issues a POST request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"ExampleClient.html#process_headers/1","title":"ExampleClient.process_headers/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_headers/1."},{"ref":"ExampleClient.html#process_request_body/1","title":"ExampleClient.process_request_body/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_request_body/1."},{"ref":"ExampleClient.html#process_request_headers/1","title":"ExampleClient.process_request_headers/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_request_headers/1."},{"ref":"ExampleClient.html#process_request_options/1","title":"ExampleClient.process_request_options/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_request_options/1."},{"ref":"ExampleClient.html#process_request_params/1","title":"ExampleClient.process_request_params/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_request_params/1."},{"ref":"ExampleClient.html#process_request_url/1","title":"ExampleClient.process_request_url/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_request_url/1."},{"ref":"ExampleClient.html#process_request_url/2","title":"ExampleClient.process_request_url/2","type":"function","doc":""},{"ref":"ExampleClient.html#process_response/1","title":"ExampleClient.process_response/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_response/1."},{"ref":"ExampleClient.html#process_response_body/1","title":"ExampleClient.process_response_body/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_response_body/1."},{"ref":"ExampleClient.html#process_response_chunk/1","title":"ExampleClient.process_response_chunk/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_response_chunk/1."},{"ref":"ExampleClient.html#process_response_headers/1","title":"ExampleClient.process_response_headers/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_response_headers/1."},{"ref":"ExampleClient.html#process_response_status_code/1","title":"ExampleClient.process_response_status_code/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_response_status_code/1."},{"ref":"ExampleClient.html#process_status_code/1","title":"ExampleClient.process_status_code/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_status_code/1."},{"ref":"ExampleClient.html#process_url/1","title":"ExampleClient.process_url/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_url/1."},{"ref":"ExampleClient.html#put/4","title":"ExampleClient.put/4","type":"function","doc":"Issues a PUT request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"ExampleClient.html#put!/4","title":"ExampleClient.put!/4","type":"function","doc":"Issues a PUT request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"ExampleClient.html#request/1","title":"ExampleClient.request/1","type":"function","doc":"Issues an HTTP request using a Request struct. This function returns {:ok, response} or {:ok, async_response} if the request is successful, {:error, reason} otherwise. Examples request = %HTTPoison.Request{ method: :post, url: &quot;https://my.website.com&quot;, body: &quot;{\\&quot;foo\\&quot;: 3}&quot;, headers: [{&quot;Accept&quot;, &quot;application/json&quot;}] } request(request)"},{"ref":"ExampleClient.html#request/5","title":"ExampleClient.request/5","type":"function","doc":"Issues an HTTP request with the given method to the given url. This function is usually used indirectly by get/3, post/4, put/4, etc Args: method - HTTP method as an atom (:get, :head, :post, :put, :delete, etc.) url - target url as a binary string or char list body - request body. See more below headers - HTTP headers as an orddict (e.g., [{&quot;Accept&quot;, &quot;application/json&quot;}]) options - Keyword list of options Body: see type HTTPoison.Request Options: see type HTTPoison.Request This function returns {:ok, response} or {:ok, async_response} if the request is successful, {:error, reason} otherwise. Examples request(:post, &quot;https://my.website.com&quot;, &quot;{\\&quot;foo\\&quot;: 3}&quot;, [{&quot;Accept&quot;, &quot;application/json&quot;}])"},{"ref":"ExampleClient.html#request!/5","title":"ExampleClient.request!/5","type":"function","doc":"Issues an HTTP request with the given method to the given url, raising an exception in case of failure. request!/5 works exactly like request/5 but it returns just the response in case of a successful request, raising an exception in case the request fails."},{"ref":"ExampleClient.html#secure?/0","title":"ExampleClient.secure?/0","type":"function","doc":"Determines whether requests are made over HTTP or HTTPS."},{"ref":"ExampleClient.html#start/0","title":"ExampleClient.start/0","type":"function","doc":"Starts HTTPoison and its dependencies."},{"ref":"ExampleClient.html#stream_next/1","title":"ExampleClient.stream_next/1","type":"function","doc":"Requests the next message to be streamed for a given HTTPoison.AsyncResponse. See request!/5 for more detailed information."},{"ref":"ExampleClient.html#t:body/0","title":"ExampleClient.body/0","type":"type","doc":""},{"ref":"ExampleClient.html#t:headers/0","title":"ExampleClient.headers/0","type":"type","doc":""},{"ref":"ExampleClient.html#t:options/0","title":"ExampleClient.options/0","type":"type","doc":""},{"ref":"ExampleClient.html#t:params/0","title":"ExampleClient.params/0","type":"type","doc":""},{"ref":"ExampleClient.html#t:request/0","title":"ExampleClient.request/0","type":"type","doc":""},{"ref":"ExampleClient.html#t:url/0","title":"ExampleClient.url/0","type":"type","doc":""}]